#!/usr/bin/env octave-cli

% parse command line
args = argv();
if nargin ~= 2,
    error(sprintf(['Incorrect number of arguments.\n' ...
        'Usage: demosaick-mlri.m input output\n']));
end
input  = args{1};
output = args{2};

pkg load image % required Octave packages
addpath([fileparts(mfilename('fullpath')), '/EI2014_MLRI_code']);

%pattern = 'rggb';
pattern = 'bggr';

input = double(iio_read(input));

bayer = input;
if size(input,3) == 4,
	% apply mosaic
	h = size(input,1);
	w = size(input,2);
	bayer = zeros(2*h,2*w);
	bayer(1:2:end,1:2:end) = input(:,:,4); % r
	bayer(2:2:end,1:2:end) = input(:,:,3); % g
	bayer(1:2:end,2:2:end) = input(:,:,2); % g
	bayer(2:2:end,2:2:end) = input(:,:,1); % b
else
	bayer = input;
end



% pre-processing on bayer
%bayer = 255*((bayer - 18) / 1005.).^(1/2.2);


% demosaick
rgb = demosaick(bayer, pattern, 1.4);
iio_write(output, rgb);

%real_rgb = zeros(size(rgb));
%real_rgb(:,:,1) = rgb(:,:,3);
%real_rgb(:,:,2) = rgb(:,:,2);
%real_rgb(:,:,3) = rgb(:,:,1);
%
%iio_write(output, real_rgb);
