import numpy as np

def noiseModel(ISO=3200):

    if ISO == 3200:
        a, b = 8.0034, -2043.51144
        
    elif ISO == 12800:
        a, b = 28.3015, -6307.62081

    a = a / 4095
    b = b / 4095 / 4095
    
    return a, b

def addNoise(imgC, ISO=3500):    
    #recover the corresponding noise parameters for an image of dynamic 0-1
    a,b = noiseModel(ISO)
    #adapt the noise parameters for a 10b image
    a = a * 1023
    b = b * 1023 * 1023

    # #load image and convert to float (data is stored as unsigned short int)
    # imgC = np.fromfile('./00000002.raw',dtype = np.uint16).astype(np.float).reshape([720,1280])

    #compute the noise variance
    varN = a * imgC + b
    varN[varN < 0] = 0 # positive variance

    #add noise and clip within the 10b range
    imgN = imgC + np.sqrt(varN) * np.random.normal(0,1,imgC.shape)
    imgN[imgN < 0] = 0
    imgN[imgN > 1023] = 1023

    # #convert back to unsigned short int and prepare the image to be written 
    # imgN = imgN.astype(np.uint16)
    # imgN.tofile('00000002_noisy.raw')

    return imgN.astype(np.uint16)
